// This code was compiled using nvcc:
// nvcc - ptx bsxfun_plus_col_row_d.cu --gpu - architecture = sm_52 - ccbin "C:\Program Files(x86)\Microsoft Visual Studio 12.0\VC\bin" 

#include "cuda.h"

// A is a matrix with nr rows, nc columns
// col is added to every cokumn of A, row is added to every row of A
// B is the output
void __global__ bsxfun_plus_col_row(double const * const A, 
    double const * const col, double const * const row, 
    int nr, int nc, double *B)
{
	int index = blockDim.x * blockIdx.x + threadIdx.x;
	int ri = index % nr, ci = index / nr, rci = ci * nr + ri;
	if (ri >= nr || ci >= nc) return;

	B[rci] = A[rci] + col[ri] + row[ci];
}