function [X,T] = readOff(filename)

fid = fopen(filename,'r');
if( fid==-1 )
    error('Cannot open the file.');
    return;
end

str = fgets(fid);   % -1 if eof

if ~strcmp(str(1:3), 'OFF') && ~strcmp(str(1:4), 'COFF')
    error('The file is not a valid OFF one.');    
end
is_coff=0;
if strcmp(str(1:4), 'COFF')
    is_coff = 1;
end

str = fgets(fid);
sizes = sscanf(str, '%d %d', 2);
while length(sizes) ~= 2
    str = fgets(fid);
    sizes = sscanf(str, '%d %d', 2);
end
nv = sizes(1);
nf = sizes(2);

% Read vertices
if is_coff
    [X,cnt] = fscanf(fid,'%lf %lf %lf 192 192 192 255\n', [3,nv]);
else
    [X,cnt] = fscanf(fid,'%lf %lf %lf\n', [3,nv]);
end
if cnt~=3*nv
    warning('Problem in reading vertices.');
end
X = X';

[T,cnt] = fscanf(fid,'3 %ld %ld %ld\n', [3,inf]);
T = T'+1;

fclose(fid);